#!/usr/bin/perl

######################################################################
package Cognition::uF::xoxo;
######################################################################

use XML::LibXML qw(:all);
use XML::XOXO;
use strict;

BEGIN
{
	our $VERSION = 0.1;
	our @ISA = qw(Cognition::uF);
}


sub parse_all
{
	my $page   = shift;
	my $within = shift || $page->{DOM};
	my @rv;
	
	my @nodes = Cognition::HTMLParser::Utils::searchClass('xoxo', $within);
	foreach my $l (@nodes)
	{
		my $l_parsed = parse($page, $l);
		push @rv, $l_parsed;
	}
	
	return @rv;
} #/sub parse_all


sub uri
{
	my $this = shift;
	my $all  = shift;
	my @rv;
	
	if (length $this->{_id})
	{
		push @rv, $this->{_page}->abs_url.'#'.$this->{_id};
	}
	push @rv, Cognition::HTMLParser::Utils::BNodeURI($this->{_dom}, 'List')
		unless (@rv);
	# push @rv, Cognition::HTMLParser::Utils::XPointer($this->{_dom}, $this->{_page}->abs_url);
	
	return $rv[0] unless (defined $all);
	while ($all) { shift @rv; $all--; }
	return @rv;
}


sub parse
{
	my $page = shift;
	my $rv = { '_dom'=>shift };
	my $list_node = $rv->{'_dom'}->cloneNode(1);

	my $id = $list_node->getAttribute('id');
	$rv->{_id} = $id if (length $id);
	$rv->{_page} = $page;
	
	my $parser = XML::XOXO::Parser->new();
	$rv->{'object'} = $parser->parse($list_node->toString);
	
	bless $rv;
	return $rv;
	
} #/sub parse


1; #/package Cognition::uF::xoxo




